# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ResourceHealth::Mgmt::V2018_08_01_preview
  module Models
    #
    # impactedResource with health status
    #
    class ImpactedResourceStatus < Resource

      include MsRestAzure

      # @return [AvailabilityStateValues] Impacted resource status of the
      # resource. Possible values include: 'Available', 'Unavailable',
      # 'Degraded', 'Unknown'
      attr_accessor :availability_state

      # @return [String] Title description of the impacted resource status.
      attr_accessor :title

      # @return [String] Summary description of the impacted resource status.
      attr_accessor :summary

      # @return [ReasonTypeValues] When the resource's availabilityState is
      # Unavailable, it describes where the health impacting event was
      # originated. Possible values include: 'Unplanned', 'Planned',
      # 'UserInitiated'
      attr_accessor :reason_type

      # @return [DateTime] Timestamp for when last change in health status
      # occurred.
      attr_accessor :occured_time


      #
      # Mapper for ImpactedResourceStatus class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'impactedResourceStatus',
          type: {
            name: 'Composite',
            class_name: 'ImpactedResourceStatus',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              availability_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.availabilityState',
                type: {
                  name: 'String'
                }
              },
              title: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.title',
                type: {
                  name: 'String'
                }
              },
              summary: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.summary',
                type: {
                  name: 'String'
                }
              },
              reason_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.reasonType',
                type: {
                  name: 'String'
                }
              },
              occured_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.occuredTime',
                type: {
                  name: 'DateTime'
                }
              }
            }
          }
        }
      end
    end
  end
end
